# Copyright (C) 2003 Gregoire Lejeune <gregoire.lejeune@free.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

module Asp
  class Common
   
  def Common::version
    return '0.0.3'
  end
  
  def Common::sessionID
    return 'session-id'
  end

  def Common::url_decode( value ) 
    value.tr( "+", " " )
    return value.to_s.gsub(/%[0-9a-fA-F]{2}/n){ |x| sprintf("%s", x[1..-1].hex.chr) }
  end

  def Common::url_encode( s )
    return s.to_s.gsub(/[^a-zA-Z0-9_\-.]/n){ sprintf("%%%02X", $&.unpack("C")[0]) }
  end
  
  def Common::time2str( time )
    return time.strftime( "%a, %d %b %Y %H:%M:%S GMT" ) # Wed, 09 Feb 1994 22:23:32 GMT
  end
  
  def Common::str2time( time )
    return time ## TODO !!!
  end
  
  def Common::html_escape( s )
    return s.to_s.gsub(/&/, "&amp;").gsub(/\"/, "&quot;").gsub(/>/, "&gt;").gsub(/</, "&lt;")
  end

  end
end
