# Copyright (C) 2003 Gregoire Lejeune <gregoire.lejeune@free.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

module Asp
  class Server
    require 'asp/common'
	require 'xml/libxml'
	require 'xml/libxslt'
    
    public
	def file
	  return @oApacheRequest.filename.dup
	end

	def html_encode( data )
	  return Common::html_escape( data )
	end

	def mapPath( path )
	  # Given the url $url, absolute, or relative to the current executing
	  # script
	end
	
	def mail
	end

	def url_encode( data )
	  return Common::url_encode( data )
	end

	def url
	end

	def xslt( xsl_data, xml_data )
	  tmpdir = (ENV['TMPDIR'] || ENV['TMP'] || ENV['TEMP'] || '/tmp').untaint
	  xsl_file = Tempfile.new("xsl" + ".", tmpdir)
	  xml_file = Tempfile.new("xml" + ".", tmpdir)
	  result = nil
	  begin
	    xsl_file.print( xsl_data )
		xsl_file.close
	    xml_file.print( xml_data )
		xml_file.close

	    xslt = XML::XSLT.file( xsl_file.path )
	    xslt.doc = XML::Document.file( xml_file.path )
	    out = xslt.parse
	    out.apply
		result = out.to_s
	  rescue => e
		result = "ERROR !" + @oApacheRequest.escape_html(e.message)
	  ensure 
		xsl_file.close
		xml_file.close
	  end

	  return result
	end
    
    private 
    def initialize( r )
	  @oApacheRequest = r
    end
  
  end
end 
